#!/usr/bin/env python

"""
The controversial "begat" benchmark. This module must be compiled using
libxml2macro.py before use, and must then be invoked directly as a compiled
module - ie. as begat.pyc.
"""

import libxml2macro as n_
import time, os

raw_input("Start your engines with ps -p %s -fv" % os.getpid())
t = time.time()

l = []
n_doc = parseFile("ot.xml")
for n_node in n_doc.xpath("//v[contains(text(), 'begat')]"):
    text = n_node.nodeValue
    l.append(text)

# NOTE: Code corresponding to this was suggested for cElementTree, but why not
# NOTE: take full advantage of XPath if you have most of the code written in C?
#
# for n_node in n_doc.xpath("//v"):
#     text = n_node.nodeValue
#     if text.find(u'begat') != -1:
#         print text

print "Time taken", time.time() - t
raw_input("Stop your engines!")

print l

# vim: tabstop=4 expandtab shiftwidth=4
